/*
 * Read BTO text files and translate to .MAT format
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXLINES (500*180) // 3 minutes

int buf[MAXLINES*9];

void p_error(char errstr[])
{
   char ss[256];
   
   puts(errstr);
   fgets(ss, strlen(ss), stdin);
   exit(EXIT_FAILURE);
}

void readTextFile(char *fspec, int *nlines)
{
  FILE *fp;
  char ss[256];
  int i;

  if ((fp = fopen(fspec,"rt")) == NULL) {
     sprintf(ss, "Can't open %s for reading\n",fspec);
     p_error(ss) ;
  }
  i = 0;
  while (!feof(fp) && (i<MAXLINES*9))
  {
     if (9 != fscanf(fp, "%d %d %d %d %d %d %d %d %d", &buf[i], &buf[i+1],
        &buf[i+2], &buf[i+3], &buf[i+4], &buf[i+5],
        &buf[i+6], &buf[i+7], &buf[i+8]))
     break; else i += 9;
  }
  fclose(fp);
  *nlines = i/9;
} /* readTextFile */


int main(int argc, char *argv[])
{
   char ss[256];
   int nlines;

   if (argc != 2)
   {
      printf("\n   Usage: text2mat <fname>\n");
      printf("  Translates <fname> into <fname>.mat \n");
      return(EXIT_FAILURE);
   }
   printf("Reading text file %s\n", argv[1]);
   readTextFile(argv[1], &nlines);
   printf("Done, lines read = %d", nlines);
   fgets(ss, strlen(ss), stdin);
   return(EXIT_SUCCESS);
}




