unit pd_hcaps;

interface
//=======================================================================
//
// NAME:    pd_hcaps.h
//
// SYNOPSIS:
//
//      Capabilities definition header file of UEI PowerDAQ DLL
//
//
// DESCRIPTION:
//
//      This file contains error and condition definition constants
//
// OPTIONS: none
//
//
// DIAGNOSTICS:
//
//
// NOTES:   See notice below.
//
// AUTHOR:  A.I. 
//
// DATE:    14-JAN-98
//
// REV:     1.0.8
//
// R DATE:  22-DEC-99
//
// HISTORY:
//
//      Rev 0.1,      14-JAN-98,  A.I.,   Initial version.
//      Rev 1.0.1,    14-MAY-98,  A.I.,   PD_MF family members added
//      Rev 1.0.2,    25-JAN-99,  A.I.,   PD_MF_16_50 added
//      Rev 1.0.3,    10-MAR-99,  SeNS,   PD_MFS_6_1M added
//      Rev 1.0.5,    06-MAY-99,  A.I.,   PD2_MF series added
//      Rev 1.0.6,    14-SEP-99,  A.I.,   Integrated into DLL
//      Rev 1.0.7,    07-DEC-99,  A.I.,   PD2_MFS/DG models added
//      Rev 1.0.8     22-DEC-99,  A.I.,   Function prototypes moved to pdhcaps32.h
//
//
//
//-----------------------------------------------------------------------
//
//      Copyright (C) 1998 United Electronic Industries, Inc.
//      All rights reserved.
//      United Electronic Industries Confidential Information.
//
//-----------------------------------------------------------------------

uses
{$IFDEF MSWINDOWS}
  Windows,
{$ENDIF}
  pwrdaq_struct,
  pwrdaq32;

// DO NOT EDIT THIS FILE

const DAQ_Info : array[0..PD_BRD_LST-1] of DAQ_Information  =
(
(
iBoardID : $101;
lpBoardName : 'PD-MF-16-330/12L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:15 12:AO:0:01 8:DI:0:0 8:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 330000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $800;
wAndMask : $fff;
),

(
iBoardID : $102;
lpBoardName : 'PD-MF-16-330/12H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:15 12:AO:0:01 8:DI:0:0 8:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 330000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $800;
wAndMask : $fff;
),

(
iBoardID : $103;
lpBoardName : 'PD-MF-64-330/12L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:63 12:AO:0:01 8:DI:0:0 8:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 330000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $800;
wAndMask : $fff;
),

(
iBoardID : $104;
lpBoardName : 'PD-MF-64-330/12H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:63 12:AO:0:01 8:DI:0:0 8:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 330000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $800;
wAndMask : $fff;
),

(
iBoardID : $105;
lpBoardName : 'PD-MF-16-1M/12L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:15 12:AO:0:01 8:DI:0:0 8:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 1250000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $800;
wAndMask : $fff;
),

(
iBoardID : $106;
lpBoardName : 'PD-MF-16-1M/12H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:15 12:AO:0:01 8:DI:0:0 8:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 1250000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $800;
wAndMask : $fff;
),

(
iBoardID : $107;
lpBoardName : 'PD-MF-64-1M/12L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:63 12:AO:0:01 8:DI:0:0 8:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 1250000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $800;
wAndMask : $fff;
),

(
iBoardID : $108;
lpBoardName : 'PD-MF-64-1M/12H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:63 12:AO:0:01 8:DI:0:0 8:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 1250000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $800;
wAndMask : $fff;
),

(
iBoardID : $109;
lpBoardName : 'PD-MF-16-250/16L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AI:0:15 12:AO:0:01 8:DI:0:0 8:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 250000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $10a;
lpBoardName : 'PD-MF-16-250/16H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AI:0:15 12:AO:0:01 8:DI:0:0 8:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 250000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $10b;
lpBoardName : 'PD-MF-64-250/16L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AI:0:63 12:AO:0:01 8:DI:0:0 8:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 250000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $10c;
lpBoardName : 'PD-MF-64-250/16H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AI:0:63 12:AO:0:01 8:DI:0:0 8:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 250000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $10d;
lpBoardName : 'PD-MF-16-50/16L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AI:0:15 12:AO:0:01 8:DI:0:0 8:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 50000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $10e;
lpBoardName : 'PD-MF-16-50/16H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AI:0:15 12:AO:0:01 8:DI:0:0 8:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 50000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $10f;
lpBoardName : 'PD-MFS-6-1M/12';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:05 12:AO:0:01 8:DI:0:0 8:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 1250000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $800;
wAndMask : $fff;
),

(
iBoardID : $110;
lpBoardName : 'Not assigned';
lpBusType : 'No';
lpDSPRAM : 'No';
lpChannels : 'No';
lpTrigCaps : 'No';
lpAInRanges : 'No';
lpAInGains : 'No';
lpTransferTypes : 'No';
iMaxAInRate : 0;
lpAOutRanges : 'No';
iMaxAOutRate : 0;
lpUCTType : 'No';
iMaxUCTRate : 0;
iMaxDIORate : 0;
wXorMask : $0;
wAndMask : $0;
),

(
iBoardID : $111;
lpBoardName : 'PD2-MF-16-400/14L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 400000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $112;
lpBoardName : 'PD2-MF-16-400/14H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 400000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $113;
lpBoardName : 'PD2-MF-64-400/14L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 400000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $114;
lpBoardName : 'PD2-MF-64-400/14H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 400000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $115;
lpBoardName : 'PD2-MF-16-800/14L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 800000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $116;
lpBoardName : 'PD2-MF-16-800/14H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 800000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $117;
lpBoardName : 'PD2-MF-64-800/14L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 800000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $118;
lpBoardName : 'PD2-MF-64-800/14H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 800000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $119;
lpBoardName : 'PD2-MF-16-1M/12L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 1250000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fff0;
),

(
iBoardID : $11a;
lpBoardName : 'PD2-MF-16-1M/12H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 1250000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fff0;
),

(
iBoardID : $11b;
lpBoardName : 'PD2-MF-64-1M/12L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 1250000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fff0;
),

(
iBoardID : $11c;
lpBoardName : 'PD2-MF-64-1M/12H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 1250000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fff0;
),

(
iBoardID : $11d;
lpBoardName : 'PD2-MF-16-50/16L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 50000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $11e;
lpBoardName : 'PD2-MF-16-50/16H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 50000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $11f;
lpBoardName : 'PD2-MF-64-50/16L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 50000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $120;
lpBoardName : 'PD2-MF-64-50/16H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 50000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $121;
lpBoardName : 'PD2-MF-16-333/16L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 333000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $122;
lpBoardName : 'PD2-MF-16-333/16H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 333000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $123;
lpBoardName : 'PD2-MF-64-333/16L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 333000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $124;
lpBoardName : 'PD2-MF-64-333/16H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 333000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $125;
lpBoardName : 'PD2-MF-16-2M/14L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 2200000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $126;
lpBoardName : 'PD2-MF-16-2M/14H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 2200000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $127;
lpBoardName : 'PD2-MF-64-2M/14L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 2200000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $128;
lpBoardName : 'PD2-MF-64-2M/14H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 2200000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $129;
lpBoardName : 'PD2-MF-16-3M/12L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 3000000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fff0;
),

(
iBoardID : $12a;
lpBoardName : 'PD2-MF-16-3M/12H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 3000000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fff0;
),

(
iBoardID : $12b;
lpBoardName : 'PD2-MF-64-3M/12L';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 10 100 1000';
lpTransferTypes : 'INT BM';
iMaxAInRate : 3000000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fff0;
),

(
iBoardID : $12c;
lpBoardName : 'PD2-MF-64-3M/12H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 3000000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fff0;
),

(
iBoardID : $12d;
lpBoardName : 'PD2-MFS-4-500/14';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10';
lpAInGains : '1 1 1 1';
lpTransferTypes : 'INT BM';
iMaxAInRate : 500000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $12e;
lpBoardName : 'PD2-MFS-8-500/14';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10';
lpAInGains : '1 1 1 1';
lpTransferTypes : 'INT BM';
iMaxAInRate : 500000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $12f;
lpBoardName : 'PD2-MFS-4-500/14DG';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 5 10';
lpTransferTypes : 'INT BM';
iMaxAInRate : 500000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $130;
lpBoardName : 'PD2-MFS-4-500/14H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 500000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $131;
lpBoardName : 'PD2-MFS-8-500/14DG';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 5 10';
lpTransferTypes : 'INT BM';
iMaxAInRate : 500000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $132;
lpBoardName : 'PD2-MFS-8-500/14H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 500000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $133;
lpBoardName : 'PD2-MFS-4-800/14';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10';
lpAInGains : '1 1 1 1';
lpTransferTypes : 'INT BM';
iMaxAInRate : 800000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $134;
lpBoardName : 'PD2-MFS-8-800/14';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10';
lpAInGains : '1 1 1 1';
lpTransferTypes : 'INT BM';
iMaxAInRate : 800000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $135;
lpBoardName : 'PD2-MFS-4-800/14DG';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 5 10';
lpTransferTypes : 'INT BM';
iMaxAInRate : 800000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $136;
lpBoardName : 'PD2-MFS-4-800/14H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 800000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $137;
lpBoardName : 'PD2-MFS-8-800/14DG';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 5 10';
lpTransferTypes : 'INT BM';
iMaxAInRate : 800000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $138;
lpBoardName : 'PD2-MFS-8-800/14H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 800000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $139;
lpBoardName : 'PD2-MFS-4-1M/12';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10';
lpAInGains : '1 1 1 1';
lpTransferTypes : 'INT BM';
iMaxAInRate : 1250000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fff0;
),

(
iBoardID : $13a;
lpBoardName : 'PD2-MFS-8-1M/12';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10';
lpAInGains : '1 1 1 1';
lpTransferTypes : 'INT BM';
iMaxAInRate : 1250000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fff0;
),

(
iBoardID : $13b;
lpBoardName : 'PD2-MFS-4-1M/12DG';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 5 10';
lpTransferTypes : 'INT BM';
iMaxAInRate : 1250000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fff0;
),

(
iBoardID : $13c;
lpBoardName : 'PD2-MFS-4-1M/12H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 1250000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fff0;
),

(
iBoardID : $13d;
lpBoardName : 'PD2-MFS-8-1M/12DG';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 5 10';
lpTransferTypes : 'INT BM';
iMaxAInRate : 1250000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fff0;
),

(
iBoardID : $13e;
lpBoardName : 'PD2-MFS-8-1M/12H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '12:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 1250000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fff0;
),

(
iBoardID : $13f;
lpBoardName : 'PD2-MFS-4-2M/14';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10';
lpAInGains : '1 1 1 1';
lpTransferTypes : 'INT BM';
iMaxAInRate : 2200000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $140;
lpBoardName : 'PD2-MFS-8-2M/14';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10';
lpAInGains : '1 1 1 1';
lpTransferTypes : 'INT BM';
iMaxAInRate : 2200000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $141;
lpBoardName : 'PD2-MFS-4-2M/14DG';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 5 10';
lpTransferTypes : 'INT BM';
iMaxAInRate : 2200000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $142;
lpBoardName : 'PD2-MFS-4-2M/14H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 2200000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $143;
lpBoardName : 'PD2-MFS-8-2M/14DG';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 5 10';
lpTransferTypes : 'INT BM';
iMaxAInRate : 2200000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $144;
lpBoardName : 'PD2-MFS-8-2M/14H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '14:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 2200000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $fffc;
),

(
iBoardID : $145;
lpBoardName : 'PD2-MFS-4-300/16';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10';
lpAInGains : '1 1 1 1';
lpTransferTypes : 'INT BM';
iMaxAInRate : 333000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $146;
lpBoardName : 'PD2-MFS-8-300/16';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10';
lpAInGains : '1 1 1 1';
lpTransferTypes : 'INT BM';
iMaxAInRate : 333000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $147;
lpBoardName : 'PD2-MFS-4-300/16DG';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 5 10';
lpTransferTypes : 'INT BM';
iMaxAInRate : 333000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $148;
lpBoardName : 'PD2-MFS-4-300/16H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 333000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $149;
lpBoardName : 'PD2-MFS-8-300/16DG';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 5 10';
lpTransferTypes : 'INT BM';
iMaxAInRate : 333000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $14a;
lpBoardName : 'PD2-MFS-8-300/16H';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
lpTrigCaps : 'S X';
lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
lpAInGains : '1 2 4 8';
lpTransferTypes : 'INT BM';
iMaxAInRate : 333000;
lpAOutRanges : 'B10';
iMaxAOutRate : 100000;
lpUCTType : '82C54';
iMaxUCTRate : 8000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $14b;
lpBoardName : 'PD2-DIO-64';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:DI:0:3 16:DO:0:3 24:CT:0:2 0:SI:0:1';
lpTrigCaps : 'S X';
lpAInRanges : 'No';
lpAInGains : 'No';
lpTransferTypes : 'INT BM';
iMaxAInRate : 0;
lpAOutRanges : 'No';
iMaxAOutRate : 0;
lpUCTType : 'MOT56301';
iMaxUCTRate : 33000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $14c;
lpBoardName : 'PD2-DIO-128';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
lpTrigCaps : 'S X';
lpAInRanges : 'No';
lpAInGains : 'No';
lpTransferTypes : 'INT BM';
iMaxAInRate : 0;
lpAOutRanges : 'No';
iMaxAOutRate : 0;
lpUCTType : 'MOT56301';
iMaxUCTRate : 33000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $14d;
lpBoardName : 'PD2-DIO-256';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:DI:0:15 16:DO:0:15 24:CT:0:2 0:SI:0:1';
lpTrigCaps : 'S X';
lpAInRanges : 'No';
lpAInGains : 'No';
lpTransferTypes : 'INT BM';
iMaxAInRate : 0;
lpAOutRanges : 'No';
iMaxAOutRate : 0;
lpUCTType : 'MOT56301';
iMaxUCTRate : 33000000;
iMaxDIORate : 1000000;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $14e;
lpBoardName : 'PD2-AO-8/16';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AO:0:7 24:CT:0:02 0:SI:0:1';
lpTrigCaps : 'S X';
lpAInRanges : 'No';
lpAInGains : 'No';
lpTransferTypes : 'INT BM';
iMaxAInRate : 0;
lpAOutRanges : 'B10';
iMaxAOutRate : 200000;
lpUCTType : 'MOT56301';
iMaxUCTRate : 0;
iMaxDIORate : 0;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $14f;
lpBoardName : 'PD2-AO-16/16';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AO:0:15 24:CT:0:02 0:SI:0:1';
lpTrigCaps : 'S X';
lpAInRanges : 'No';
lpAInGains : 'No';
lpTransferTypes : 'INT BM';
iMaxAInRate : 0;
lpAOutRanges : 'B10';
iMaxAOutRate : 200000;
lpUCTType : 'MOT56301';
iMaxUCTRate : 0;
iMaxDIORate : 0;
wXorMask : $8000;
wAndMask : $ffff;
),

(
iBoardID : $150;
lpBoardName : 'PD2-AO-32/16';
lpBusType : 'PCI';
lpDSPRAM : 'MOT56301 24KI';
lpChannels : '16:AO:0:31 24:CT:0:02 0:SI:0:1';
lpTrigCaps : 'S X';
lpAInRanges : 'No';
lpAInGains : 'No';
lpTransferTypes : 'INT BM';
iMaxAInRate : 0;
lpAOutRanges : 'B10';
iMaxAOutRate : 200000;
lpUCTType : 'MOT56301';
iMaxUCTRate : 0;
iMaxDIORate : 0;
wXorMask : $8000;
wAndMask : $ffff;
),

(
    iBoardID : $151;
    lpBoardName : 'PD2-AO-96/16';
    lpBusType : 'PCI';
    lpDSPRAM : 'MOT56301 24KI';
    lpChannels : '16:AO:0:95 8:DI:0:0 8:DO:0:0 24:CT:0:02 0:SI:0:1';
    lpTrigCaps : 'S X';
    lpAInRanges : 'No';
    lpAInGains : 'No';
    lpTransferTypes : 'INT BM';
    iMaxAInRate : 0;
    lpAOutRanges : 'B10';
    iMaxAOutRate : 100000;
    lpUCTType : 'MOT56301';
    iMaxUCTRate : 0;
    iMaxDIORate : 0;
    wXorMask : 0;
    wAndMask : 0;
  ),

   (
    iBoardID : $152;
    lpBoardName : 'PD2-AO-R1';
    lpBusType : 'PCI';
    lpDSPRAM : 'MOT56301 24KI';
    lpChannels : '16:AO:0:31 8:DI:0:0 8:DO:0:0 24:CT:0:02 0:SI:0:1';
    lpTrigCaps : 'S X';
    lpAInRanges : 'No';
    lpAInGains : 'No';
    lpTransferTypes : 'INT BM';
    iMaxAInRate : 0;
    lpAOutRanges : 'B10';
    iMaxAOutRate : 200000;
    lpUCTType : 'MOT56301';
    iMaxUCTRate : 0;
    iMaxDIORate : 0;
    wXorMask : 0;
    wAndMask : 0;
  ),

   (
    iBoardID : $153;
    lpBoardName : 'PD2-AO-R2';
    lpBusType : 'PCI';
    lpDSPRAM : 'MOT56301 24KI';
    lpChannels : '16:AO:0:31 8:DI:0:0 8:DO:0:0 24:CT:0:02 0:SI:0:1';
    lpTrigCaps : 'S X';
    lpAInRanges : 'No';
    lpAInGains : 'No';
    lpTransferTypes : 'INT BM';
    iMaxAInRate : 0;
    lpAOutRanges : 'B10';
    iMaxAOutRate : 200000;
    lpUCTType : 'MOT56301';
    iMaxUCTRate : 0;
    iMaxDIORate : 0;
    wXorMask : 0;
    wAndMask : 0;
  ),

   (
    iBoardID : $154;
    lpBoardName : 'PD2-AO-R3';
    lpBusType : 'PCI';
    lpDSPRAM : 'MOT56301 24KI';
    lpChannels : '16:AO:0:31 8:DI:0:0 8:DO:0:0 24:CT:0:02 0:SI:0:1';
    lpTrigCaps : 'S X';
    lpAInRanges : 'No';
    lpAInGains : 'No';
    lpTransferTypes : 'INT BM';
    iMaxAInRate : 0;
    lpAOutRanges : 'B10';
    iMaxAOutRate : 200000;
    lpUCTType : 'MOT56301';
    iMaxUCTRate : 0;
    iMaxDIORate : 0;
    wXorMask : 0;
    wAndMask : 0;
  ),

   (
    iBoardID : $155;
    lpBoardName : 'PD2-AO-R4';
    lpBusType : 'PCI';
    lpDSPRAM : 'MOT56301 24KI';
    lpChannels : '16:AO:0:31 8:DI:0:0 8:DO:0:0 24:CT:0:02 0:SI:0:1';
    lpTrigCaps : 'S X';
    lpAInRanges : 'No';
    lpAInGains : 'No';
    lpTransferTypes : 'INT BM';
    iMaxAInRate : 0;
    lpAOutRanges : 'B10';
    iMaxAOutRate : 200000;
    lpUCTType : 'MOT56301';
    iMaxUCTRate : 0;
    iMaxDIORate : 0;
    wXorMask : 0;
    wAndMask : 0;
  ),

   (
    iBoardID : $156;
    lpBoardName : 'PD2-AO-R5';
    lpBusType : 'PCI';
    lpDSPRAM : 'MOT56301 24KI';
    lpChannels : '16:AO:0:31 8:DI:0:0 8:DO:0:0 24:CT:0:02 0:SI:0:1';
    lpTrigCaps : 'S X';
    lpAInRanges : 'No';
    lpAInGains : 'No';
    lpTransferTypes : 'INT BM';
    iMaxAInRate : 0;
    lpAOutRanges : 'B10';
    iMaxAOutRate : 200000;
    lpUCTType : 'MOT56301';
    iMaxUCTRate : 0;
    iMaxDIORate : 0;
    wXorMask : 0;
    wAndMask : 0;
  ),
                   
   (
    iBoardID : $157;
    lpBoardName : 'PD2-AO-R6';
    lpBusType : 'PCI';
    lpDSPRAM : 'MOT56301 24KI';
    lpChannels : '16:AO:0:31 8:DI:0:0 8:DO:0:0 24:CT:0:02 0:SI:0:1';
    lpTrigCaps : 'S X';
    lpAInRanges : 'No';
    lpAInGains : 'No';
    lpTransferTypes : 'INT BM';
    iMaxAInRate : 0;
    lpAOutRanges : 'B10';
    iMaxAOutRate : 200000;
    lpUCTType : 'MOT56301';
    iMaxUCTRate : 0;
    iMaxDIORate : 0;
    wXorMask : 0;
    wAndMask : 0;
  ),

   (
    iBoardID : $158;
    lpBoardName : 'PD2-AO-R7';
    lpBusType : 'PCI';
    lpDSPRAM : 'MOT56301 24KI';
    lpChannels : '16:AO:0:31 8:DI:0:0 8:DO:0:0 24:CT:0:02 0:SI:0:1';
    lpTrigCaps : 'S X';
    lpAInRanges : 'No';
    lpAInGains : 'No';
    lpTransferTypes : 'INT BM';
    iMaxAInRate : 0;
    lpAOutRanges : 'B10';
    iMaxAOutRate : 200000;
    lpUCTType : 'MOT56301';
    iMaxUCTRate : 0;
    iMaxDIORate : 0;
    wXorMask : 0;
    wAndMask : 0;
  ),
                 
// extended DIO series
   (
     iBoardID : $159;
     lpBoardName : 'PD2-DIO-64CE';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:3 16:DO:0:3 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),
                 
   (
     iBoardID : $15A;
     lpBoardName : 'PD2-DIO-128CE';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $15B;
     lpBoardName : 'PD2-DIO-64ST';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:3 16:DO:0:3 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),
                 
   (
     iBoardID : $15C;
     lpBoardName : 'PD2-DIO-128ST';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask :  $0;
  ),

   (
     iBoardID : $15D;
     lpBoardName : 'PD2-DIO-64HS';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:3 16:DO:0:3 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),
                 
   (
     iBoardID : $15E;
     lpBoardName : 'PD2-DIO-128HS';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $15F;
     lpBoardName : 'PD2-DIO-64CT';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:3 16:DO:0:3 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),
                 
   (
     iBoardID : $160;
     lpBoardName : 'PD2-DIO-128CT';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),
                 
   (
     iBoardID : $161;
     lpBoardName : 'PD2-DIO-R0';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),
                 
   (
     iBoardID : $162;
     lpBoardName : 'PD2-DIO-R1';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $163;
     lpBoardName : 'PD2-DIO-R2';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $164;
     lpBoardName : 'PD2-DIO-R3';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $165;
     lpBoardName : 'PD2-DIO-R4';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),

                   
   (
     iBoardID : $166;
     lpBoardName : 'PD2-DIO-R5';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $167;
     lpBoardName : 'PD2-DIO-R6';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $168;
     lpBoardName : 'PD2-DIO-R7';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),
                 
// 16-bit multifunction SSH high speed (500 kHz)
   (
     iBoardID : $169;
     lpBoardName : 'PD2-MFS-4-500/16';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10';
     lpAInGains : '1 1 1 1';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                 
   (
     iBoardID : $16A;
     lpBoardName : 'PD2-MFS-8-500/16';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10';
     lpAInGains : '1 1 1 1';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                 
   (
     iBoardID : $16B;
     lpBoardName : 'PD2-MFS-4-500/16DG';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 5 10';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                 
   (
     iBoardID : $16C;
     lpBoardName : 'PD2-MFS-4-500/16H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                 
   (
     iBoardID : $16D;
     lpBoardName : 'PD2-MFS-8-500/16DG';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 5 10';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                 
   (
     iBoardID : $16E;
     lpBoardName : 'PD2-MFS-8-500/16H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                 
// 16-bit multifunction (100 kHz)
   (
     iBoardID : $16F;
     lpBoardName : 'PD2-MF-16-100/16L';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 10 100 1000';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 100000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                 
   (
     iBoardID : $170;
     lpBoardName : 'PD2-MF-16-100/16H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 100000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                 
   (
     iBoardID : $171;
     lpBoardName : 'PD2-MF-64-100/16L';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 10 100 1000';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 100000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                 
   (
     iBoardID : $172;
     lpBoardName : 'PD2-MF-64-100/16H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 100000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                 
   (
     iBoardID : $173;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 200000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                 
   (
     iBoardID : $174;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 200000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $175;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $176;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $177;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $178;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

                   
   (
     iBoardID : $179;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $17A;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $17B;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $17C;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $17D;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $17E;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $17F;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $180;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $181;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $182;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $183;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $184;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $185;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $186;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $187;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
  
   (
     iBoardID : $188;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $189;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $18A;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                 
   (
     iBoardID : $18B;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

 (
     iBoardID : $18C;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $18D;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $18E;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $18F;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $190;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $191;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $192;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $193;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $194;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $195;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $196;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $197;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $198;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $199;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $19A;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $19B;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $19C;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),
  
   (
     iBoardID : $19D;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $19E;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $19F;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),
  
     (
     iBoardID : $1A0;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1A1;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1A2;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1A3;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1A4;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1A5;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1A6;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1A7;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1A8;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1A9;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1AA;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1AB;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1AC;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),
  
   (
     iBoardID : $1AD;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1AE;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1AF;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),


   (
     iBoardID : $1B0;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1B1;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1B2;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1B3;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1B4;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1B5;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1B6;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1B7;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1B8;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1B9;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1BA;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1BB;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1BC;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),
  
   (
     iBoardID : $1BD;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1BE;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1BF;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1C0;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1C1;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1C2;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1C3;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1C4;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1C5;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1C6;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1C7;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1C8;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1C9;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1CA;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1CB;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1CC;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),
  
   (
     iBoardID : $1CD;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1CE;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1CF;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),


   (
     iBoardID : $1D0;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1D1;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1D2;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1D3;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1D4;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1D5;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1D6;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1D7;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1D8;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1D9;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1DA;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1DB;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1DC;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),
  
   (
     iBoardID : $1DD;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1DE;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1DF;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),


   (
     iBoardID : $1E0;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1E1;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1E2;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1E3;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1E4;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1E5;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1E6;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1E7;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1E8;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1E9;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1EA;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1EB;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1EC;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),
  
   (
     iBoardID : $1ED;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1EE;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1EF;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),


   (
     iBoardID : $1F0;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1F1;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1F2;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1F3;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1F4;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1F5;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1F6;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1F7;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1F8;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1F9;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1FA;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1FB;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1FC;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),
  
   (
     iBoardID : $1FD;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1FE;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $1FF;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $200;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $201;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $202;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $203;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $204;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $205;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $206;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $207;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $208;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $209;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $20A;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $20B;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $20C;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),
  
   (
     iBoardID : $20D;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $20E;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $20F;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),


                 
// PowerDAQ II series
//
// 14-bit multifunction low speed (400 kHz)

   (
     iBoardID : $211;
     lpBoardName : 'PDXI-MF-16-400/14L';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 10 100 1000';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 400000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $212;
     lpBoardName : 'PDXI-MF-16-400/14H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 400000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $213;
     lpBoardName : 'PDXI-MF-64-400/14L';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 10 100 1000';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 400000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $214;
     lpBoardName : 'PDXI-MF-64-400/14H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 400000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
// 14-bit multifunction medium speed (800 kHz)
   (
     iBoardID : $215;
     lpBoardName : 'PDXI-MF-16-800/14L';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 10 100 1000';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 800000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                   
   (
     iBoardID : $216;
     lpBoardName : 'PDXI-MF-16-800/14H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 800000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $217;
     lpBoardName : 'PDXI-MF-64-800/14L';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 10 100 1000';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 800000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $218;
     lpBoardName : 'PDXI-MF-64-800/14H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 800000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
                                  
// 12-bit multifunction high speed (1 MHz)
   (
     iBoardID : $219;
     lpBoardName : 'PDXI-MF-16-1M/12L';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '12:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 10 100 1000';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 1250000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFF0;
  ),
                                  
   (
     iBoardID : $21A;
     lpBoardName : 'PDXI-MF-16-1M/12H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '12:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 1250000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFF0;
  ),
                                  
   (
     iBoardID : $21B;
     lpBoardName : 'PDXI-MF-64-1M/12L';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '12:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 10 100 1000';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 1250000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFF0;
  ),
                                  
   (
     iBoardID : $21C;
     lpBoardName : 'PDXI-MF-64-1M/12H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '12:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 1250000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFF0;
  ),
                                  
 // 16-bit multifunction (50 kHz)
   (
     iBoardID : $21D;
     lpBoardName : 'PDXI-MF-16-50/16L';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 10 100 1000';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 50000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $21E;
     lpBoardName : 'PDXI-MF-16-50/16H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 50000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $21F;
     lpBoardName : 'PDXI-MF-64-50/16L';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 10 100 1000';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 50000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $220;
     lpBoardName : 'PDXI-MF-64-50/16H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 50000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
// 16-bit multifunction (333 kHz)
   (
     iBoardID : $221;
     lpBoardName : 'PDXI-MF-16-333/16L';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 10 100 1000';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $222;
     lpBoardName : 'PDXI-MF-16-333/16H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $223;
     lpBoardName : 'PDXI-MF-64-333/16L';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 10 100 1000';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $224;
     lpBoardName : 'PDXI-MF-64-333/16H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
  
// 14-bit multifunction high speed (2 2 MHz)
   (
     iBoardID : $225;
     lpBoardName : 'PDXI-MF-16-2M/14L';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 10 100 1000';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 2200000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $226;
     lpBoardName : 'PDXI-MF-16-2M/14H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 2200000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $227;
     lpBoardName : 'PDXI-MF-64-2M/14L';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 10 100 1000';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 2200000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $228;
     lpBoardName : 'PDXI-MF-64-2M/14H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 2200000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                                                    
// 16-bit multifunction high speed (500 kHz)
   (
     iBoardID : $229;
     lpBoardName : 'PDXI-MF-16-500/16L';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 10 100 1000';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $22A;
     lpBoardName : 'PDXI-MF-16-500/16H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $22B;
     lpBoardName : 'PDXI-MF-64-500/16L';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 10 100 1000';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $22C;
     lpBoardName : 'PDXI-MF-64-500/16H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
// PowerDAQ II SSH section ---------------------
// 14-bit multifunction SSH low speed (400 kHz)
   (
     iBoardID : $22D;
     lpBoardName : 'PDXI-MFS-4-500/14';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10';
     lpAInGains : '1 1 1 1';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $22E;
     lpBoardName : 'PDXI-MFS-8-500/14';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10';
     lpAInGains : '1 1 1 1';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $22F;
     lpBoardName : 'PDXI-MFS-4-500/14DG';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 5 10';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $230;
     lpBoardName : 'PDXI-MFS-4-500/14H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $231;
     lpBoardName : 'PDXI-MFS-8-500/14DG';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 5 10';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $232;
     lpBoardName : 'PDXI-MFS-8-500/14H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
 // 14-bit multifunction SSH medium speed (800 kHz)
   (
     iBoardID : $233;
     lpBoardName : 'PDXI-MFS-4-800/14';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10';
     lpAInGains : '1 1 1 1';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 800000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $234;
     lpBoardName : 'PDXI-MFS-8-800/14';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10';
     lpAInGains : '1 1 1 1';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 800000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $235;
     lpBoardName : 'PDXI-MFS-4-800/14DG';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 5 10';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 800000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $236;
     lpBoardName : 'PDXI-MFS-4-800/14H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 800000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $237;
     lpBoardName : 'PDXI-MFS-8-800/14DG';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 5 10';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 800000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $238;
     lpBoardName : 'PDXI-MFS-8-800/14H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 800000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
// 12-bit multifunction SSH high speed (1 25 MHz)
   (
     iBoardID : $239;
     lpBoardName : 'PDXI-MFS-4-1M/12';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '12:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10';
     lpAInGains : '1 1 1 1';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 1250000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFF0;
  ),
                                  
   (
     iBoardID : $23A;
     lpBoardName : 'PDXI-MFS-8-1M/12';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '12:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10';
     lpAInGains : '1 1 1 1';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 1250000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFF0;
  ),
                                  
   (
     iBoardID : $23B;
     lpBoardName : 'PDXI-MFS-4-1M/12DG';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '12:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 5 10';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 1250000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFF0;
  ),
                                  
   (
     iBoardID : $23C;
     lpBoardName : 'PDXI-MFS-4-1M/12H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '12:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 1250000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFF0;
  ),
                                  
   (
     iBoardID : $23D;
     lpBoardName : 'PDXI-MFS-8-1M/12DG';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '12:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 5 10';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 1250000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFF0;
  ),
                                  
   (
     iBoardID : $23E;
     lpBoardName : 'PDXI-MFS-8-1M/12H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '12:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 1250000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFF0;
  ),
                                  
// 14-bit multifunction SSH high speed (2 2 MHz)
                                  
   (
     iBoardID : $23F;
     lpBoardName : 'PDXI-MFS-4-2M/14';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10';
     lpAInGains : '1 1 1 1';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 2200000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $240;
     lpBoardName : 'PDXI-MFS-8-2M/14';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10';
     lpAInGains : '1 1 1 1';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 2200000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $241;
     lpBoardName : 'PDXI-MFS-4-2M/14DG';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 5 10';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 2200000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $242;
     lpBoardName : 'PDXI-MFS-4-2M/14H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 2200000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $243;
     lpBoardName : 'PDXI-MFS-8-2M/14DG';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 5 10';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 2200000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
   (
     iBoardID : $244;
     lpBoardName : 'PDXI-MFS-8-2M/14H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '14:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 2200000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFC;
  ),
                                  
// 16-bit multifunction SSH high speed (333 kHz)
   (
     iBoardID : $245;
     lpBoardName : 'PDXI-MFS-4-300/16';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10';
     lpAInGains : '1 1 1 1';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $246;
     lpBoardName : 'PDXI-MFS-8-300/16';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10';
     lpAInGains : '1 1 1 1';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $247;
     lpBoardName : 'PDXI-MFS-4-300/16DG';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 5 10';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $248;
     lpBoardName : 'PDXI-MFS-4-300/16H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $249;
     lpBoardName : 'PDXI-MFS-8-300/16DG';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 5 10';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $24A;
     lpBoardName : 'PDXI-MFS-8-300/16H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
// DIO series
   (
     iBoardID : $24B;
     lpBoardName : 'PDXI-DIO-64';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:3 16:DO:0:3 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),
                                  
   (
     iBoardID : $24C;
     lpBoardName : 'PDXI-DIO-128';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),
                                  
   (
     iBoardID : $24D;
     lpBoardName : 'PDXI-DIO-256';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:15 16:DO:0:15 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),
                                  
// AO series
   (
     iBoardID : $24E;
     lpBoardName : 'PDXI-AO-8/16';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AO:0:7 8:DI:0:0 8:DO:0:0 24:CT:0:02 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 100000;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : $0;
     wAndMask : $0;
  ),
                                  
   (
     iBoardID : $24F;
     lpBoardName : 'PDXI-AO-16/16';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AO:0:15 8:DI:0:0 8:DO:0:0 24:CT:0:02 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 100000;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : $0;
     wAndMask : $0;
  ),
                                  
   (
     iBoardID : $250;
     lpBoardName : 'PDXI-AO-32/16';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AO:0:31 8:DI:0:0 8:DO:0:0 24:CT:0:02 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 100000;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : $0;
     wAndMask : $0;
  ),
                                  
   (
     iBoardID : $251;
     lpBoardName : 'PDXI-AO-R0';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AO:0:31 8:DI:0:0 8:DO:0:0 24:CT:0:02 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 100000;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $252;
     lpBoardName : 'PDXI-AO-R1';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AO:0:31 8:DI:0:0 8:DO:0:0 24:CT:0:02 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $253;
     lpBoardName : 'PDXI-AO-R2';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AO:0:31 8:DI:0:0 8:DO:0:0 24:CT:0:02 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $254;
     lpBoardName : 'PDXI-AO-R3';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AO:0:31 8:DI:0:0 8:DO:0:0 24:CT:0:02 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $255;
     lpBoardName : 'PDXI-AO-R4';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AO:0:31 8:DI:0:0 8:DO:0:0 24:CT:0:02 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : $0;
     wAndMask : $0;
  ),
                                     
   (
     iBoardID : $256;
     lpBoardName : 'PDXI-AO-R5';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AO:0:31 8:DI:0:0 8:DO:0:0 24:CT:0:02 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $257;
     lpBoardName : 'PDXI-AO-R6';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AO:0:31 8:DI:0:0 8:DO:0:0 24:CT:0:02 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $258;
     lpBoardName : 'PDXI-AO-R7';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AO:0:31 8:DI:0:0 8:DO:0:0 24:CT:0:02 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : $0;
     wAndMask : $0;
  ),
                                  
// extended DIO series
   (
     iBoardID : $259;
     lpBoardName : 'PDXI-DIO-64CE';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:3 16:DO:0:3 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),
                                  
   (
     iBoardID : $25A;
     lpBoardName : 'PDXI-DIO-128CE';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $25B;
     lpBoardName : 'PDXI-DIO-64ST';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:3 16:DO:0:3 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),
                                  
   (
     iBoardID : $25C;
     lpBoardName : 'PDXI-DIO-128ST';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $25D;
     lpBoardName : 'PDXI-DIO-64HS';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:3 16:DO:0:3 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),
                                  

   (
     iBoardID : $25E;
     lpBoardName : 'PDXI-DIO-128HS';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $25F;
     lpBoardName : 'PDXI-DIO-64CT';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:3 16:DO:0:3 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),
                                  

   (
     iBoardID : $260;
     lpBoardName : 'PDXI-DIO-128CT';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),

                                  
   (
     iBoardID : $261;
     lpBoardName : 'PDXI-DIO-R0';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),
                                  
   (
     iBoardID : $262;
     lpBoardName : 'PDXI-DIO-R1';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $263;
     lpBoardName : 'PDXI-DIO-R2';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $264;
     lpBoardName : 'PDXI-DIO-R3';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $265;
     lpBoardName : 'PDXI-DIO-R4';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $266;
     lpBoardName : 'PDXI-DIO-R5';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $267;
     lpBoardName : 'PDXI-DIO-R6';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),

   (
     iBoardID : $268;
     lpBoardName : 'PDXI-DIO-R7';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:DI:0:7 16:DO:0:7 24:CT:0:2 0:SI:0:1';
     lpTrigCaps : 'S X';
     lpAInRanges : 'No';
     lpAInGains : 'No';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 0;
     lpAOutRanges : 'No';
     iMaxAOutRate : 0;
     lpUCTType : 'MOT56301';
     iMaxUCTRate : 33000000;
     iMaxDIORate : 1000000;
     wXorMask : $0;
     wAndMask : $0;
  ),
                                  
// 16-bit multifunction SSH high speed (500 kHz)
                                  
   (
     iBoardID : $269;
     lpBoardName : 'PDXI-MFS-4-500/16';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10';
     lpAInGains : '1 1 1 1';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $26A;
     lpBoardName : 'PDXI-MFS-8-500/16';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10';
     lpAInGains : '1 1 1 1';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $26B;
     lpBoardName : 'PDXI-MFS-4-500/16DG';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 5 10';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $26C;
     lpBoardName : 'PDXI-MFS-4-500/16H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:3 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $26D;
     lpBoardName : 'PDXI-MFS-8-500/16DG';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 5 10';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  

   (
     iBoardID : $26E;
     lpBoardName : 'PDXI-MFS-8-500/16H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:7 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
// 16-bit multifunction (200 kHz)
   (
     iBoardID : $26F;
     lpBoardName : 'PDXI-MF-16-200/16L';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 10 100 1000';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 500000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $270;
     lpBoardName : 'PDXI-MF-16-200/16H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:15 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 200000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $271;
     lpBoardName : 'PDXI-MF-64-200/16L';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 10 100 1000';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 200000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $272;
     lpBoardName : 'PDXI-MF-64-200/16H';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 200000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $273;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 200000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                  
   (
     iBoardID : $274;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 200000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $275;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $276;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $277;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $278;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $279;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $27A;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

                                     
   (
     iBoardID : $27B;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
                                     
   (
     iBoardID : $27C;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $27D;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $27E;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $27F;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $280;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $281;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $282;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $283;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $284;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $285;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $286;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $287;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $288;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $289;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),

   (
     iBoardID : $28A;
     lpBoardName : 'reserved';
     lpBusType : 'PCI';
     lpDSPRAM : 'MOT56301 24KI';
     lpChannels : '16:AI:0:63 12:AO:0:01 16:DI:0:0 16:DO:0:0 16:CT:0:02';
     lpTrigCaps : 'S X';
     lpAInRanges : 'SU5 SU10 SB5 SB10 DU5 DU10 DB5 DB10 ';
     lpAInGains : '1 2 4 8';
     lpTransferTypes : 'INT BM';
     iMaxAInRate : 333000;
     lpAOutRanges : 'B10';
     iMaxAOutRate : 200000;
     lpUCTType : '82C54';
     iMaxUCTRate : 8000000;
     iMaxDIORate : 1000000;
     wXorMask : $8000;
     wAndMask : $FFFF;
  ),
        
   (
     iBoardID : $28B;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $28C;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),

   (
     iBoardID : $28D;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  ),
   (
     iBoardID : $28E;
     lpBoardName : 'x';
     lpBusType : 'x';
     lpDSPRAM : 'x';
     lpChannels : 'x';
     lpTrigCaps : 'x';
     lpAInRanges : 'x';
     lpAInGains : 'x';
     lpTransferTypes : 'x';
     iMaxAInRate : 0;
     lpAOutRanges : 'x';
     iMaxAOutRate : 0;
     lpUCTType : 'x';
     iMaxUCTRate : 0;
     iMaxDIORate : 0;
     wXorMask : 0;
     wAndMask : 0;
  )


);

implementation
begin
end.